//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <vcl\registry.hpp>
#include "Delils3Unit.h"
#include "DirFormUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Eyes"
#pragma resource "*.dfm"
TDelilsFrm *DelilsFrm;
//---------------------------------------------------------------------------
__fastcall TDelilsFrm::TDelilsFrm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDelilsFrm::BitBtn1Click(TObject *Sender)
{
    ListView1->Items->Clear();
    StartDir = Edit1->Text;
    FindFilesInDirectory(StartDir);
}
//---------------------------------------------------------------------------
void __fastcall TDelilsFrm::BitBtn2Click(TObject *Sender)
{
	if(MessageBox(0, "Really Delete Selected File(s)?", "Verify....", MB_YESNO) == IDYES)
    {
        int count = ListView1->Items->Count;
        for(int i = count; i; i--)
        {
            if(ListView1->Items->Item[i-1]->Selected)
            {
                 DeleteFile(ListView1->Items->Item[i-1]->Caption.c_str());
                 ListView1->Items->Item[i-1]->Delete();

			}
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TDelilsFrm::FormShow(TObject *Sender)
{
    TRegistry *Reg = new TRegistry();
    Reg->RootKey = HKEY_CURRENT_USER;
    try{
        Reg->OpenKey("Software\\Kgm\\Delils", false);
        Top = Reg->ReadInteger("Top");
        Left = Reg->ReadInteger("Left");
        Width = Reg->ReadInteger("Width");
        Height = Reg->ReadInteger("Height");
        RadioGroup1->ItemIndex = Reg->ReadInteger("Version");
        ComboBox1->ItemIndex = Reg->ReadInteger("File Type");
        Reg->Free();
    }
    catch(...)
    {
        Reg->Free();
        ComboBox1->ItemIndex = 0;
    };

    GetStartDir(StartDir);
}
//---------------------------------------------------------------------------
void __fastcall TDelilsFrm::Button1Click(TObject *Sender)
{
    DirForm->DirectoryListBox1->Directory = Edit1->Text;
    DirForm->ShowModal();
	if(DirForm->ModalResult == ID_OK)
    {
    	StartDir = DirForm->DirectoryListBox1->Directory;
        if(StartDir[StartDir.Length()] != '\\') StartDir += "\\";
    	Edit1->Text = StartDir;
    }
}
//---------------------------------------------------------------------------
void TDelilsFrm::GetStartDir(String &StartDir)
{
	TRegistry *Reg = new TRegistry;
    Reg->RootKey = HKEY_LOCAL_MACHINE;
    if(Reg->OpenKey("SOFTWARE\\Borland\\C++Builder", false))
    {
        Reg->CloseKey();
        try
        {
            if(RadioGroup1->ItemIndex)
                    Reg->OpenKey("SOFTWARE\\Borland\\C++Builder\\3.0", false);
            else    Reg->OpenKey("SOFTWARE\\Borland\\C++Builder\\1.0", false);
            StartDir = Reg->ReadString("RootDir");
            if(StartDir == "") StartDir = "c:";
        }
        catch(...)
        {
            StartDir = "C:";
        };
    }
    else StartDir = "C:";
    StartDir += "\\";
    Reg->Free();
    Edit1->Text = StartDir;
}
//---------------------------------------------------------------------------
void TDelilsFrm::FindFilesInDirectory (String &directory)
{
  // Changed Edit1 to ComboBox1
  // This method searches the directory specified by the parameter and all
  // of its subdirectories for the file matching the value in Edit1.
  // The directory name is assumed to end with a backslash.

  WIN32_FIND_DATA filedata ;  // Structure for file data
  HANDLE filehandle ;         // Handle for searching
  //Edit2->Text = directory;
  // Pass 1 - Search for the files within the directory.
  filehandle = FindFirstFile ((directory + ComboBox1->Text).c_str (), &filedata) ;
  if (filehandle != INVALID_HANDLE_VALUE)
  {
    do
    {
      // Display the file name.
      TListItem *li = ListView1->Items->Add () ;
      li->Caption = directory + filedata.cFileName ;

      // Display the file size.
      if (filedata.nFileSizeHigh == 0)
      {
        li->SubItems->Add (String ((int) ((filedata.nFileSizeLow + 1023)/1024)) + " K") ;
      }
      else
      {
        // If nFileSizeHigh is non-zero then this is a **HUGE** file.
        double filesize = (MAXDWORD * filedata.nFileSizeHigh) + filedata.nFileSizeLow ;
        li->SubItems->Add (String (filesize / 1024.0) + " K") ;
      }

      // Display the MS-DOS name for the file.
      li->SubItems->Add (String (filedata.cAlternateFileName)) ;

      Application->ProcessMessages () ;

    } while (FindNextFile (filehandle, &filedata)) ;
    FindClose (filehandle) ;
  }

  // Pass 2 - Search for all the subdirectories within this directory
  String dir = directory + "*.*" ;
  filehandle = FindFirstFile ((directory + "*.*").c_str (), &filedata) ;
  if (filehandle != INVALID_HANDLE_VALUE)
  {
    do
    {
      if ((filedata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0
           && String (filedata.cFileName) != "."
           && String (filedata.cFileName) != "..")
      {
        // Recursive call here
        FindFilesInDirectory (directory + filedata.cFileName + "\\") ;
      }

      Application->ProcessMessages () ;
    } while (FindNextFile (filehandle, &filedata)) ;
    FindClose (filehandle) ;
  }

  Application->ProcessMessages () ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TDelilsFrm::BitBtn3Click(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------
void __fastcall TDelilsFrm::RadioGroup1Click(TObject *Sender)
{
    GetStartDir(StartDir);
}
//---------------------------------------------------------------------------

void __fastcall TDelilsFrm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    TRegistry *Reg = new TRegistry();
    Reg->RootKey = HKEY_CURRENT_USER;
    Reg->OpenKey("Software\\Kgm\\Delils", true);
    Reg->WriteInteger("Top", Top);
    Reg->WriteInteger("Left", Left);
    Reg->WriteInteger("Width", Width);
    Reg->WriteInteger("Height", Height);
    Reg->WriteInteger("Version", RadioGroup1->ItemIndex);
    Reg->WriteInteger("File Type", ComboBox1->ItemIndex);
    Reg->Free();    
}
//---------------------------------------------------------------------------

